import { VMObject } from "./VMObject";
import { minType } from "../decorators/minVersion";
import { validation } from "../decorators/validation";
import { Control } from "./Control";

export class Strip extends VMObject {
  @validation()
  public get Mono(): boolean {
    return this.getParamValueBoolean(this.buildParameterString("Mono"))[1];
  }
  public set Mono(v: boolean) {
    this.setParamValueBoolean(this.buildParameterString("Mono"), v);
  }

  @validation()
  public get Mute(): boolean {
    return this.getParamValueBoolean(this.buildParameterString("Mute"))[1];
  }
  public set Mute(v: boolean) {
    this.setParamValueBoolean(this.buildParameterString("Mute"), v);
  }

  @validation()
  public get EQEnabled(): boolean {
    return this.getParamValueBoolean(this.buildParameterString("EQ", "on"))[1];
  }
  public set EQEnabled(v: boolean) {
    this.setParamValueBoolean(this.buildParameterString("EQ", "on"), v);
  }

  @validation()
  public get EQVariant(): boolean {
    return this.getParamValueBoolean(this.buildParameterString("EQ", "AB"))[1];
  }
  public set EQVariant(v: boolean) {
    this.setParamValueBoolean(this.buildParameterString("EQ", "AB"), v);
  }

  @validation()
  public get Gain(): number {
    return this.getParamValueNumber(this.buildParameterString("Gain"))[1];
  }
  public set Gain(v: number) {
    this.setParamValueNumber(this.buildParameterString("Gain"), v);
  }

  constructor(
    control: Control,
    public id: number
  ) {
    // control.validation();
    super(control, "Bus", id);
  }

  initialize(): void {
    console.log("Nothing to initialize");
  }
}
