import { Control } from "../VMR/Control";
import { Strip } from "../VMR/Strip";
import { throwError } from "../utils/Error";

type validateThisType = Control | Strip;

export function validate(this: validateThisType) {
  let isValid = true;
  if (this instanceof Control && !this.loggedIn) isValid = false;
  else if (this instanceof Strip && !this.control.loggedIn) isValid = false;
  if (!isValid) return throwError("Communication pipe isn't open");
}

export function validation() {
  return (object: any, name: string, descriptor: PropertyDescriptor) => {
    const keys = ["set", "get", "value"] as (keyof typeof descriptor)[];
    for (const key of keys) {
      if (descriptor[key] === undefined) continue;
      const originalFunction = descriptor[key];
      descriptor[key] = function (this: validateThisType, ...args: any[]) {
        validate.bind(this)();
        return originalFunction.apply(this, args);
      };
    }
    return descriptor;
  };
}
